/*
FYI: This project was initially (around 2006 summer) named sharptorrent, but when it came out that theres already project 
named sharptorrent in sourceforge, it was renamed to sharktorrent.
*/
#include "sharktorrent.h"
#include "sharktorrentframe.h"

IMPLEMENT_APP(sharkTorrentApp)

bool sharkTorrentApp::OnInit()
{
	// Checking for another instance
	const wxString name = wxString::Format(_T("sharktorrent-%s"), wxGetUserId().c_str());
    m_checker = new wxSingleInstanceChecker(name, _T("/tmp/"));
    if ( m_checker->IsAnotherRunning() )
    {
    	if(argc >=2) {
			std::cout << "argc=" << argc << "\n";
    		wxClient *_client = new wxClient();
    		_client->MakeConnection(_T("localhost"), _T("/tmp/sharktorrent.ipc"), wxString(argv[1]));
    		return false;
    	} else {
        	wxLogError(_("Another program instance is already running, aborting."));
        	return false;
        }
    }

	// This is necessary
	boost::filesystem::path::default_name_check(boost::filesystem::no_check);

	SetVendorName(_T("sfinks"));
	SetAppName(_T("sharktorrent"));
	
	// Check for configuration paths and filename, if does'nt exists then create.
	
	wxString confDirName = wxStandardPaths::Get().GetUserDataDir();
	if( !wxFileName::DirExists( confDirName )) {	
		bool b = wxFileName::Mkdir(confDirName); 
		if(!b) wxLogMessage(_T("failed to create directory ") + confDirName);
	}
	
	wxString confTorrentsDirName = wxStandardPaths::Get().GetUserDataDir() + _T("/torrents/");
	if( !wxFileName::DirExists( confTorrentsDirName )) {	
		bool b = wxFileName::Mkdir(confTorrentsDirName); 
		if(!b) wxLogMessage(_T("failed to create directory ") + confTorrentsDirName);
	}
	
	wxString confFileName = wxStandardPaths::Get().GetUserDataDir() + _T("/sharktorrent.conf");
	if( !wxFileName::FileExists( confFileName )) {
		wxFile *f = new wxFile();
		bool b = f->Create( confFileName.c_str());
		
		if(!b) wxLogMessage(_T("failed to file directory ") + confFileName);
	}
	
	// TODO: restore previous sessions size, consider users resolution etc...
	frame = new sharkTorrentFrame( wxT( "sharkTorrent "ST_VERSION ), wxPoint(0,0), wxSize(800,600) );
	frame->Show(TRUE);
	frame->FirstInit();
	SetTopWindow(frame);
	SetExitOnFrameDelete(true);
	return TRUE;
} 

int sharkTorrentApp::OnExit()
{
	std::cout << "int sharkTorrentApp::OnExit()" << "\n";
	delete m_checker;
    return 0;
}
