#include "stconfigdialog.h"

stConfigDialog::stConfigDialog(wxWindow* win)
{
    SetExtraStyle(wxDIALOG_EX_CONTEXTHELP|wxWS_EX_VALIDATE_RECURSIVELY);

	Create(win, wxID_ANY, _("Preferences"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER );
	
	wxWindow *p1 = this;
	
	wxStaticBox *sbox = new wxStaticBox(p1, wxID_ANY, wxT("Configuration"));
	wxStaticBoxSizer *sz1 = new wxStaticBoxSizer(sbox, wxVERTICAL);
	wxFlexGridSizer *sz2 = new wxFlexGridSizer(13, 2, 4, 4);

	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("max downloads ( 0 = no limit)") ), 1, wxGROW|wxALL, 0);
	m_maxdl = new wxTextCtrl(p1, wxID_ANY);
	m_maxdl->SetEditable(true);
	sz2->Add( m_maxdl, 1, wxALIGN_LEFT, 0);
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("max uploads ( min 1 )") ), 1, wxLEFT, 0);
	m_maxul = new wxTextCtrl(p1, wxID_ANY);
	m_maxul->SetEditable(true);
	sz2->Add( m_maxul, 3, wxALIGN_LEFT, 0);

	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("max seeds ( 0 = no limit)")), 1, wxLEFT, 0);
	m_maxseeds = new wxTextCtrl(p1, wxID_ANY);
	m_maxseeds->SetEditable(true);
	sz2->Add( m_maxseeds, 0, wxALIGN_LEFT, 0);
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("max connections ( 0 = no limit)")), 1, wxLEFT, 0);
	m_maxconn = new wxTextCtrl(p1, wxID_ANY);
	//m_maxconn->SetEditable(false);
	sz2->Add( m_maxconn, 0, wxALIGN_LEFT, 0);
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("max upload speed ( 0 = no limit)")), 0, wxGROW|wxALL, 0);
	m_maxulspeed = new wxTextCtrl(p1, wxID_ANY);
	sz2->Add( m_maxulspeed, 0, wxALIGN_LEFT, 0);
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("max download speed ( 0 = no limit)")), 0, wxGROW|wxALL, 0);
	m_maxdlspeed = new wxTextCtrl(p1, wxID_ANY);
	sz2->Add( m_maxdlspeed, 0, wxALIGN_LEFT, 0);
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("port range ( suggested = 6881-6889 )")), 0, wxGROW|wxALL, 0);
	m_port = new wxTextCtrl(p1, wxID_ANY);
	m_port_end = new wxTextCtrl(p1, wxID_ANY);

	wxBoxSizer *sz3 = new wxBoxSizer( wxHORIZONTAL );
	sz3->Add( m_port, 0, wxALIGN_LEFT, 0);
	sz3->Add( new wxStaticText(p1, wxID_ANY, _T(" to ")), 0, wxGROW|wxALL, 0);
	sz3->Add( m_port_end, 0, wxALIGN_LEFT, 0);
	sz2->Add(sz3, 0, wxALIGN_LEFT, 0);
	
/*
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("udp tracker port ( default = 4444 )")), 0, wxGROW|wxALL, 0);
	m_utp = new wxTextCtrl(p1, wxID_ANY);
	sz2->Add( m_utp, 0, wxALIGN_LEFT, 0);
*/
	
	// begin FDL
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("download directory ( default = ./ )")), 1, wxGROW|wxALL, 0);
	
	sz3 = new wxBoxSizer( wxVERTICAL );
	m_fdl = new wxTextCtrl(p1, wxID_ANY, _T(""), wxDefaultPosition, wxSize(300, 25));	
	m_fdl_button = new wxButton(p1, CONF_OPENDIR, _("&Open Dir"));
	sz3->Add( m_fdl, 1,  wxGROW|wxALL, 0);
	sz3->Add( m_fdl_button, 1,  wxGROW|wxALL, 0);
	
	sz2->Add( sz3, 1,  wxGROW|wxALL, 0);
	// end FDL
	
	sz2->Add( new wxStaticText(p1, wxID_ANY, _T("")), 1, wxALL, 0);
	sz2->Add( CreateButtonSizer(wxOK|wxCANCEL), 1, wxALIGN_LEFT, 0);

	sz1->Add(sz2, 1,  wxGROW|wxALL, 0);

	SetSizer(sz1);
	sz1->Fit(this);
}

stConfigDialog::~stConfigDialog()
{
}


/*!
    \fn stConfigDialog::SetData(long dl, long seeds, long conn, long us, long ds, long port, long utp, wxString f)
 */
void stConfigDialog::SetData(long dl, long ul, long seeds, long conn, long us, long ds, long port, long port_end, long utp, wxString f)
{

	m_maxdl->SetValue( wxString::Format(_T("%d"), dl) );
	m_maxul->SetValue( wxString::Format(_T("%d"), ul) );
	m_maxseeds->SetValue( wxString::Format(_T("%d"), seeds) );
	m_maxconn->SetValue( wxString::Format(_T("%d"), conn) );
	m_maxulspeed->SetValue( wxString::Format(_T("%d"), us) );
	m_maxdlspeed->SetValue( wxString::Format(_T("%d"), ds) );
	m_port->SetValue( wxString::Format(_T("%d"), port) );
	m_port_end->SetValue( wxString::Format(_T("%d"), port_end) );
//	m_utp->SetValue( wxString::Format(_T("%d"), utp) );
	m_fdl->SetValue( f );
}

void stConfigDialog::OnOpenDir(wxCommandEvent& event) {
	wxFileInputStream fis( wxStandardPaths::Get().GetUserDataDir() + _T("/sharktorrent.conf"));
	wxFileConfig *pConfig = new wxFileConfig( (wxInputStream &)fis );
	
	wxString fdl  = pConfig->Read(_T("/Dirs/fdl"), wxStandardPaths::Get().GetUserConfigDir());
	
	wxDirDialog *f_d = new wxDirDialog(this, _T("Choose a file"), fdl);

	if(f_d->ShowModal() == wxID_OK) {
		m_fdl->SetValue(f_d->GetPath());
	} else {
	} 
}

BEGIN_EVENT_TABLE(stConfigDialog, wxDialog)
       EVT_BUTTON(CONF_OPENDIR, stConfigDialog::OnOpenDir)
END_EVENT_TABLE()
;
