#include "sttorrentmetainfogui.h"


char *colnames_files[NUM_OF_COLUMNS_IN_FILES_LIST] = {"Nr", "File", "Progress"};
char *colnames_peers[NUM_OF_COLUMNS_IN_PEERS_LIST] = {"Nr", "IP", "Client", "Down Speed", "Up Speed"};

stTorrentMetainfoGui::stTorrentMetainfoGui(wxWindow* parent, wxWindowID id, long style)
	: wxNotebook(parent, id, wxDefaultPosition, wxDefaultSize, style)
{

	SetWindowStyleFlag(wxNO_BORDER);
	Refresh();
	//m_pstatus	= new wxPanel(this, wxID_ANY);
	m_pfiles	= new wxPanel(this, wxID_ANY, wxDefaultPosition, wxDefaultSize, wxTAB_TRAVERSAL | wxNO_BORDER);
	m_ppeers	= new wxPanel(this, wxID_ANY);
	//m_pchunks	= new wxPanel(this, wxID_ANY);
	
	//AddPage(m_pstatus, _T("Status"));
	AddPage(m_pfiles, _T("Files"));
	AddPage(m_ppeers, _T("Peers"));
	//AddPage(m_pchunks, _T("Chunks"));

	//SetSelection(1);
	
	//createPageStatus();
	createPagePeers();
	createPageFiles();
}

stTorrentMetainfoGui::~stTorrentMetainfoGui()
{
}

void stTorrentMetainfoGui::createPageMetainfo()
{
}

void stTorrentMetainfoGui::createPageStatus()
{
	wxSizer *f_sizer = new wxBoxSizer(wxVERTICAL);
	m_pstatus->SetSizer(f_sizer);
	
	m_st1 = new wxStaticText(m_pstatus, -1, _T("parts downloaded"));
	m_st2 = new wxStaticText(m_pstatus, -1, _T("parts available"));

	f_sizer->Add(m_st1);//, 1,  wxALL);
	f_sizer->Add(m_st2);//, 1,  wxALL);
	//m_pstatus->Add(f_st1);
}
void stTorrentMetainfoGui::createPageFiles()
{

	wxSizer *f_sizer = new wxBoxSizer(wxVERTICAL);
	m_pfiles->SetSizer(f_sizer);

	m_lv_files = new wxListView(m_pfiles, -1);
	f_sizer->Add(m_lv_files, 1, wxEXPAND );

	

	wxListItem itemCol;
	wxString _ts1;
	for(int i=0; i<NUM_OF_COLUMNS_IN_FILES_LIST; i++) {
		itemCol.SetText( wxString::FromAscii(colnames_files[i]) );
		m_lv_files->InsertColumn(i, itemCol);
		if(i==0) m_lv_files->SetColumnWidth( i, 75 );
		if(i==1) m_lv_files->SetColumnWidth( i, 600 );
		if(i==2) m_lv_files->SetColumnWidth( i, 100 );
		//if(i==0) m_peers_lv->SetColumnWidth( i, 250);
		//if(i==1) SetColumnWidth( i, 200 );
	}
}
void stTorrentMetainfoGui::createPagePeers()
{

	wxSizer *f_sizer = new wxBoxSizer(wxVERTICAL);
	m_ppeers->SetSizer(f_sizer);

	m_lv_peers = new wxListView(m_ppeers, -1);
	f_sizer->Add(m_lv_peers, 1, wxEXPAND );

	
	//, "Choked", "Snubbed", "Availability"};

	wxListItem itemCol;
	wxString _ts1;
	for(int i=0; i<NUM_OF_COLUMNS_IN_PEERS_LIST; i++) {
		itemCol.SetText( wxString::FromAscii(colnames_peers[i]) );
		m_lv_peers->InsertColumn(i, itemCol);
		m_lv_peers->SetColumnWidth( i, 700/NUM_OF_COLUMNS_IN_PEERS_LIST );
		//if(i==0) m_peers_lv->SetColumnWidth( i, 250);
		//if(i==1) SetColumnWidth( i, 200 );
	}
}
void stTorrentMetainfoGui::createPageChunks()
{
}

/*!
    \fn stTorrentMetainfoGui::updateLists()
 */
void stTorrentMetainfoGui::updateLists(stMapHandles f_handles)
{
}
/*!
    \fn stTorrentMetainfoGui::updatePeersGui()
 */
void stTorrentMetainfoGui::updatePeersGui(torrent_handle &h)
{
	if(GetSelection() != 1) return;
	
	std::vector<peer_info> peers;
	
	h.get_peer_info(peers);
	
	int _icount=0 , f_coli;
	for (std::vector<peer_info>::const_iterator i = peers.begin();
                i != peers.end(); ++i, _icount++) 
	{
		if(m_lv_peers->GetItemCount() <= _icount) 
			m_lv_peers->InsertItem(_icount, _T(""));	
		
		f_coli=0;
		
		std::string _s;

		asio::ip::address _a =  i->ip.address();
		
		m_lv_peers->SetItem(_icount, f_coli,  wxString::Format(_T("%d"), _icount)  );
		m_lv_peers->SetItem(_icount, ++f_coli,   wxString::FromAscii(_a.to_string().c_str()));
		m_lv_peers->SetItem(_icount, ++f_coli, wxString::FromAscii(i->client.c_str()) );
		m_lv_peers->SetItem(_icount, ++f_coli, wxString::Format(_T("%.2f kB/s"), i->down_speed/1024));
		m_lv_peers->SetItem(_icount, ++f_coli, wxString::Format(_T("%.2f kB/s"), i->up_speed/1024));	
	}
	
	while(m_lv_peers->GetItemCount() > _icount && m_lv_peers->GetItemCount() > 0) {
		m_lv_peers->DeleteItem( (m_lv_peers->GetItemCount())-1);
	}
}

/*!
    \fn stTorrentMetainfoGui::updateFilesGui()
 */
void stTorrentMetainfoGui::updateFilesGui(torrent_handle &h)
{
	if(GetSelection() != 0) return;
	
	bool print_file_progress =true;
	
	if (print_file_progress && h.has_metadata())
	{
		std::vector<float> file_progress;
		h.file_progress(file_progress);
		torrent_info const& info = h.get_torrent_info();
		
		int f_icount=0, f_coli;
		for (int i = 0; i < info.num_files(); ++i, f_icount++)
		{
			if(m_lv_files->GetItemCount() <= f_icount) m_lv_files->InsertItem(f_icount, _T(""));
	
			f_coli=0;
			
			m_lv_files->SetItem(f_icount, f_coli,  wxString::Format(_T("%d"), f_icount)  );
			m_lv_files->SetItem(f_icount, ++f_coli, wxString::FromAscii( info.file_at(i).path.leaf().c_str()) );
			m_lv_files->SetItem(f_icount, ++f_coli,   wxString::Format(_T("%.2f %%"), (file_progress[i] + 0.00)*100) );
		}
		
		while(m_lv_files->GetItemCount() > f_icount && m_lv_files->GetItemCount() > 0) {
			m_lv_files->DeleteItem( (m_lv_files->GetItemCount())-1);
		}
	}
}

void stTorrentMetainfoGui::clearAll() 
{
	m_lv_files->DeleteAllItems();
	m_lv_peers->DeleteAllItems();
}
