#ifndef STTORRENTMETAINFOGUI_H
#define STTORRENTMETAINFOGUI_H

#include "wx/wx.h"
#include "wx/listctrl.h"

#include <iostream>
#include <fstream>
#include <iterator>
#include <exception>

#include <boost/format.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

#include "libtorrent/entry.hpp"
#include "libtorrent/bencode.hpp"
#include "libtorrent/session.hpp"
#include "libtorrent/torrent_info.hpp"
#include "libtorrent/asio/ip/address.hpp"

#include "helperfunctions.h"
#include "sharktorrent.h"
#include "stpairstrhandle.h"

using namespace libtorrent;

#define NUM_OF_COLUMNS_IN_PEERS_LIST 5
#define NUM_OF_COLUMNS_IN_FILES_LIST 3


/**
	@author ,,, <sfinks@users.sourceforge.net>
*/
class stTorrentMetainfoGui : public wxNotebook{
public:
	stTorrentMetainfoGui(wxWindow* parent, wxWindowID id, long style  = 0);
	~stTorrentMetainfoGui();
	void updateLists(stMapHandles f_handles);
    void updatePeersGui(torrent_handle &h);
    void updateFilesGui(torrent_handle &h);
	void clearAll();
	
	
protected:
	void createPageStatus();
	void createPageFiles();
	void createPagePeers();
	void createPageChunks();
	void createPageMetainfo();
	
private:
	wxPanel  *m_pstatus, *m_pfiles, *m_ppeers, *m_pchunks, *m_pmetainfo;

	wxStaticText *m_st1, *m_st2;

	wxListView *m_lv_peers;
	wxListView *m_lv_files;
	wxListView *m_lv_metainfo;
};

#endif
