#include "sttorrentslistctrl.h"
#include "sharktorrentframe.h"

WX_DEFINE_LIST(st1List);
		 
//int g_colcount=0;
const int NUM_COLS_TORRENTSLISTCTRL = 10;
char *colnames[NUM_COLS_TORRENTSLISTCTRL] = {"torrent name", "progress",
                "status", "size", 
				//"left",
                //"total downloaded", 
				"peers", "seeders",  "copies", "down speed",
                //"downloaded", 
				"up speed", 
				//"uploaded", 
				"ratio", 
				//"info-hash", "next announce", "tracker url"
				};

int listcompare(const void *arg1, const void *arg2)
{
	// int cols = 1 3 4 5 6 7 8 9
	return ((**(stHashMapStrLong **)arg1)[g_sortcol+1]).Compare((**(stHashMapStrLong **)arg2)[g_sortcol+1]);
	/*stStrLong m1 = (**(stHashMapStrLong **)arg1)[g_sortcol+1];
	stStrLong m2 = (**(stHashMapStrLong **)arg2)[g_sortcol+1];
	*/
	/*if((**(stHashMapStrLong **)arg1)[g_sortcol+1].IsLong()) {
		long l1 = (**(stHashMapStrLong **)arg1)[g_sortcol+1].ToLong();
		long l2 = (**(stHashMapStrLong **)arg2)[g_sortcol+1].ToLong();
		if(l1>l2) return -1;
		if(l1<l2) return 1;
		return 0;
	} else {
		wxString s1 = (**(stHashMapStrLong **)arg1)[g_sortcol+1].ToString();
		wxString s2 = (**(stHashMapStrLong **)arg2)[g_sortcol+1].ToString();
		return  s1.CmpNoCase(s2);
	}
	*/
	//return m1.Compare(m2);
	assert( 1==2 );
	return 0;
}

class sharkTorrentFrame;

BEGIN_EVENT_TABLE( stTorrentsListCtrl, wxListView )
	EVT_LIST_ITEM_SELECTED(TORRENTS_LISTVIEW,	stTorrentsListCtrl::OnSelected)
	EVT_LIST_ITEM_RIGHT_CLICK(TORRENTS_LISTVIEW, stTorrentsListCtrl::OnItemRightClick)
	EVT_LIST_COL_CLICK(TORRENTS_LISTVIEW, stTorrentsListCtrl::OnColClick)

	EVT_MENU(TORRENTS_LISTVIEW_REMOVE_TORRENT, stTorrentsListCtrl::OnPopupRemoveTorrent)
	EVT_MENU(TORRENTS_LISTVIEW_RESUME_TORRENT, stTorrentsListCtrl::OnPopupResumeTorrent)
	EVT_MENU(TORRENTS_LISTVIEW_PAUSE_TORRENT, stTorrentsListCtrl::OnPopupPauseTorrent)
END_EVENT_TABLE()

stTorrentsListCtrl::stTorrentsListCtrl()
{
}

stTorrentsListCtrl::stTorrentsListCtrl(wxWindow *parent,
               const wxWindowID id,
               const wxPoint& pos,
               const wxSize& size,
               long style )
	: wxListView(parent, id, pos, size, style)
{

	g_sortorder = 1;
	g_sortcol = 0;

	m_parent = (sharkTorrentFrame *)parent;

	wxListItem itemCol;
	wxString _ts1;
	for(int i=0; i<(NUM_COLS_TORRENTSLISTCTRL); i++) {
		itemCol.SetText( wxString::FromAscii(colnames[i]) );
		InsertColumn(i, itemCol);
		
		if(i==0) SetColumnWidth( i, 200);
		if(i>=1 && i<=17)  SetColumnWidth( i, 70);
		//if(i==1) SetColumnWidth( i, 200 );
	}
//	SetScrollbar(wxHORIZONTAL, 0, 16, 50);
//	m_index = -1;
}

stTorrentsListCtrl::~stTorrentsListCtrl()
{
}

/*!
    \fn stTorrentsListCtrl::updateList(handles_t f_handles)
 */
void stTorrentsListCtrl::updateList(stMapHandles f_handles)
{
	int _icount=0;
	float f_gdown=0, f_gup=0;
	stHashMapStrLong *l2;
	st1List *l1 = new st1List();

	for (stMapHandles::iterator i = f_handles.begin() ;  i != f_handles.end() && f_handles.size()>0; ++i, _icount++)
	{
		int f_coli=0;
		l2 = new stHashMapStrLong();
		
		(*l2)[f_coli++] = i->first;
		
		if(GetItemCount() <= _icount) InsertItem(_icount, _T(""));
		
		//torrent_handle h = f_handles[i->first].GetHandle();
		torrent_handle h = (i->second).GetHandle();
		torrent_status s = h.status();
		torrent_info ti = h.get_torrent_info();;
	
		(*l2)[f_coli++] = wxString::FromAscii(h.get_torrent_info().name().c_str());
		//(*l2)[f_coli++] = wxString::Format(_T("%.2f%%"), (s.progress)*100);
		
		//int _ii = f_coli++;
		(*l2)[f_coli].SetLong((long)(s.progress*10000));
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%.2f%%"), (s.progress)*100));

		static char const* state_str[] =
			{"queued", "checking", "connecting", "downloading metadata"
			, "downloading", "finished", "seeding", "allocating"};

		if(h.is_paused()) {
			(*l2)[f_coli++] = wxString(_T("paused"));
		} else {
			(*l2)[f_coli++] = wxString::FromAscii(state_str[s.state] );
		}

		wxString _tss;
		if( ti.total_size() > 1024*1024*1024) {
			_tss = wxString::Format(_T("%.2fG"), ti.total_size() /(float)(1024*1024*1024) );
		} else 
		if( ti.total_size() > 1024*1024) {
			_tss = wxString::Format(_T("%.1fM"), ti.total_size() /(float)(1024*1024) );
		} else 
		if( ti.total_size() > 1024) {
				_tss = wxString::Format(_T("%.1fkB"), ti.total_size() /(float)1024);
		} else {
					_tss = wxString::Format(_T("%dB"), ti.total_size() );
		} 
		
		(*l2)[f_coli].SetLong( ti.total_size()/1024 );
		(*l2)[f_coli++].SetStr(_tss);

		//++f_coli;

//		long _totalsize = (ti.total_size() / 1024);

		wxString f_totalstr;
		if(s.total_done > 1024*1024*1024 ) {
			f_totalstr = wxString::Format(_T("%.2fG"), s.total_done/(float)(1024*1024*1024));
		} else if(s.total_done > 1024*1024) {
			f_totalstr = wxString::Format(_T("%.1fM"), s.total_done/(float)(1024*1024));
		} else {
			f_totalstr = wxString::Format(_T("%.1fkB"), s.total_done/(float)1024);
		}
		//(*l2)[f_coli].SetLong( ti.total_size());	
		//(*l2)[f_coli++] = f_totalstr;
		
		(*l2)[f_coli].SetLong( s.num_peers);
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%d"), s.num_peers));
		(*l2)[f_coli].SetLong( s.num_seeds);
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%d"), s.num_seeds));
		(*l2)[f_coli].SetLong( (long)(s.distributed_copies*100));
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%.1f"), s.distributed_copies));
		(*l2)[f_coli].SetLong( (long)(s.download_rate));
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%.1fkB/s"), s.download_rate/1024));

		f_gdown += s.download_rate;
		
		f_gup += s.upload_rate;
		
		float ratio = 0;
		if( s.total_payload_upload != 0 )
			ratio = s.total_payload_download / s.total_payload_upload;
		
		std::stringstream _ss1;
		_ss1 << h.info_hash();
		
		boost::posix_time::time_duration t = s.next_announce;
		std::string t_ss = boost::posix_time::to_simple_string(t);
		std::string current_tracker = s.current_tracker;

		//(*l2)[9] = wxString::Format(_T("%dkB"), s.total_download/1024);
		(*l2)[f_coli].SetLong( (long)(s.upload_rate));
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%.1fkB/s"), s.upload_rate/1024));
		//(*l2)[11] = wxString::Format(_T("%dkB"), s.total_upload/1024);
		(*l2)[f_coli].SetLong( (long)(ratio*100 ));
		(*l2)[f_coli++].SetStr(wxString::Format(_T("%.1f"), ratio ));
		//(*l2)[13] = wxString::FromAscii( _ss1.str().c_str() );
		//(*l2)[14] = wxString::FromAscii(t_ss.c_str() );
		//(*l2)[15] = wxString::FromAscii( current_tracker.c_str() );

		l1->Append( l2);
		//delete l2;
	} // for
	
	//g_colcount =0;
	
	//wxLongLong _ca = wxGetLocalTimeMillis();
	l1->Sort(listcompare);
	
	int i=0;
	
	stHashMapStrLong *l3;
	
	if(g_sortorder == 1) {
		for ( i =0 ; i < l1->GetCount() ; i++ )
		{
			l3 = l1->Item(i)->GetData();
			for(int j=1; j<=NUM_COLS_TORRENTSLISTCTRL; j++) {
				SetItem(i, j-1, (*l3)[j].ToString());
				SetItemData(i,  ((*l3)[0]).ToLong() );
			}
			//delete l3;
		}
	} else { // if g_sortorder == 0
		int i2=0;
		for ( i = l1->GetCount()-1 ; i >= 0  ; i--, i2++ )
		{
			l3 = l1->Item(i)->GetData();
			for(int j=1; j<=NUM_COLS_TORRENTSLISTCTRL; j++) {
				SetItem(i2, j-1, (*l3)[j].ToString());

				SetItemData(i2, ((*l3)[0]).ToLong() );
			}
		}
	} 

	wxGetApp().frame->SetStatusText( wxString::Format( _T("overall download speed = %.2f kB/s, overall upload speed = %.2f kB/s"), f_gdown/1024, f_gup/1024));
	while(GetItemCount() > _icount && GetItemCount() > 0) {
		DeleteItem(GetItemCount()-1);
	}
	if(f_handles.size()>0) {
		delete l2;
		delete l1;
	}
}



/*!
    \fn stTorrentsListCtrl::OnSelected(wxListEvent& event)
 */
void stTorrentsListCtrl::OnSelected(wxListEvent& event)
{

	wxGetApp().frame->updateLists();
}

long stTorrentsListCtrl::GetSelectedItemData(int _sel) {
	if(_sel>=0 && IsSelected(_sel)) 
		return GetItemData( _sel );
	return -1;
}

long stTorrentsListCtrl::GetSelectedItemData() {
	int gfs = GetFirstSelected();
	
	if(gfs>=0 && IsSelected(gfs)) {
		return GetItemData( gfs );
	}
	return -1;
}

void stTorrentsListCtrl::OnItemRightClick(wxListEvent& event)
{
    int f_row = event.GetIndex();
    m_rightClickedRow = f_row;
	if(f_row<0 ) return;
    wxMenu menu(wxT(""));
	
	//menu.AppendSeparator();
	menu.Append(TORRENTS_LISTVIEW_PAUSE_TORRENT, _T("&Pause"));
	menu.Append(TORRENTS_LISTVIEW_RESUME_TORRENT, _T("R&esume"));
	menu.Append(TORRENTS_LISTVIEW_REMOVE_TORRENT, _T("&Remove torrent"));
	//menu.Append(TORRENTS_LISTVIEW_REMOVE_TORRENT_AND_DATA, _T("Remove torrent + &delete downloaded data"));
	//menu.AppendSeparator();
    PopupMenu(&menu, event.GetPoint());
}

void stTorrentsListCtrl::OnColClick(wxListEvent& event)
{
    int col = event.GetColumn();
	
	// compare new col with prev., if changed then do not change sortingorder
	if(g_sortcol == col) {
		g_sortorder ? g_sortorder=0  : g_sortorder = 1;
	}
    g_sortcol = col;
    

	wxGetApp().frame->updateLists();
}

void stTorrentsListCtrl::OnPopupRemoveTorrent(wxCommandEvent& event)
{
	wxGetApp().frame->RemoveSelected();
}

void stTorrentsListCtrl::OnPopupPauseTorrent(wxCommandEvent& event)
{
	wxGetApp().frame->PauseSelected();
}
	
void stTorrentsListCtrl::OnPopupResumeTorrent(wxCommandEvent& event)
{
	wxGetApp().frame->ResumeSelected();
}