#ifndef STTORRENTSLISTCTRL_H
#define STTORRENTSLISTCTRL_H

#include "wx/wx.h"
#include "wx/listctrl.h"
#include "wx/hashmap.h"
#include "wx/listimpl.cpp"

#include <iostream>
#include <fstream>
#include <iterator>
#include <exception>

#include <boost/format.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>

#include "libtorrent/entry.hpp"
#include "libtorrent/bencode.hpp"
#include "libtorrent/session.hpp"
#include "libtorrent/torrent_info.hpp"

#include "helperfunctions.h"
#include "sharktorrent.h"
#include "ststrlong.h"
#include "stpairstrhandle.h"


using namespace libtorrent;

class sharkTorrentFrame;

WX_DECLARE_HASH_MAP( int, stStrLong, wxIntegerHash, wxIntegerEqual, stHashMapStrLong );
WX_DECLARE_LIST(stHashMapStrLong, st1List);

/**
	@author ,,, <sfinks@users.sourceforge.net>
*/
class stTorrentsListCtrl: public wxListView{
	public:
		stTorrentsListCtrl();
		stTorrentsListCtrl(wxWindow *parent,
				   const wxWindowID id,
				   const wxPoint& pos,
				   const wxSize& size,
				   long style);

		~stTorrentsListCtrl();
		void updateList(stMapHandles f_handles);
		void OnSelected(wxListEvent& event);
		long GetSelectedIndex();
		long GetSelectedItemData();
		long GetSelectedItemData(int _sel);
		
		void OnColClick(wxListEvent& event);
		void OnItemRightClick(wxListEvent& event);
		void OnPopupRemoveTorrent(wxCommandEvent& event);
		void OnPopupPauseTorrent(wxCommandEvent& event);
		void OnPopupResumeTorrent(wxCommandEvent& event);

	private:
		long m_rightClickedRow;
			
	private:
		DECLARE_EVENT_TABLE();
};



enum
{
	TORRENTS_LISTVIEW,
	TORRENTS_LISTVIEW_REMOVE_TORRENT,
	TORRENTS_LISTVIEW_PAUSE_TORRENT,
	TORRENTS_LISTVIEW_RESUME_TORRENT,
	TORRENTS_LISTVIEW_REMOVE_TORRENT_AND_DATA
};

#endif
